﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.Support.V4.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Util;
using Android.Views;
using Android.Widget;
using ThinkGeo.MapSuite.Android;

namespace MapViewCrash
{
    public class MapFragment : Fragment
    {
        LayerOverlay overlay = new LayerOverlay();
        MapView mapView;

        public override void OnCreate(Bundle savedInstanceState)
        {
            HasOptionsMenu = true;
            base.OnCreate(savedInstanceState);
        }

        public override View OnCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState)
        {
            // Use this to return your custom view for this Fragment
            var view = inflater.Inflate(Resource.Layout.map_fragment, container, false);

            mapView = view.FindViewById<MapView>(Resource.Id.MapView);

            mapView.CurrentExtent = new ThinkGeo.MapSuite.Shapes.RectangleShape();
            mapView.MapUnit = ThinkGeo.MapSuite.GeographyUnit.Meter;

            return view;
        }

        public override void OnViewCreated(View view, Bundle savedInstanceState)
        {
            base.OnViewCreated(view, savedInstanceState);
            mapView.Overlays.Add(overlay);
        }

        public override void OnCreateOptionsMenu(IMenu menu, MenuInflater inflater)
        {
            base.OnCreateOptionsMenu(menu, inflater);

            var fragment2MenuItem = menu.Add("Show fragment 2");
            fragment2MenuItem.SetShowAsAction(ShowAsAction.Always | ShowAsAction.WithText);
        }

        public override bool OnOptionsItemSelected(IMenuItem item)
        {
            ((MainActivity)Activity).ShowFragment2();
            return true;
        }

        public override void OnStop()
        {
            //mapView.Overlays.Clear();
            base.OnStop();
        }
    }
}